/*
 * ARM JTAG Fault Injector
 *
 * Author: Ingo Korb <ingo@akana.de>
 *
 * Copyright (C) 2011-2014 Department of Computer Science,
 * Design Automation of Embedded Systems Group,
 * Dortmund University of Technology, all rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   3. Neither the name of the copyright holder nor the names of its
 *      contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#define MPU ((MPU_Type*) MPU_BASE)
#define CoreDebug_DCRSR_REGWnR_Msk (1ul << CoreDebug_DCRSR_REGWnR_Pos)
#define LPC_RTC ((LPC_RTC_TypeDef *) LPC_RTC_BASE )
#define SCB_AIRCR_ENDIANESS_Pos 15
#define CoreDebug_DEMCR_MON_PEND_Msk (1ul << CoreDebug_DEMCR_MON_PEND_Pos)
#define SCB_SHCSR_SVCALLACT_Msk (1ul << SCB_SHCSR_SVCALLACT_Pos)
#define MPU_RASR_TEX_Msk (7ul << MPU_RASR_TEX_Pos)
#define SCB_HFSR_VECTTBL_Pos 1
#define CONFIG_MCU_FREQ 100000000
#define CoreDebug_DEMCR_VC_NOCPERR_Pos 5
#define INT_LEAST16_MIN -32768
#define ITM_LSR_ByteAcc_Msk (1ul << ITM_LSR_ByteAcc_Pos)
#define LPC_I2C2_BASE (LPC_APB1_BASE + 0x20000)
#define MPU_RASR_ENA_Pos 0
#define MPU_RASR_SIZE_Msk (0x1Ful << MPU_RASR_SIZE_Pos)
#define CoreDebug_DEMCR_VC_CORERESET_Pos 0
#define SCB_SHCSR_BUSFAULTENA_Msk (1ul << SCB_SHCSR_BUSFAULTENA_Pos)
#define SCB_ICSR_VECTACTIVE_Pos 0
#define LPC_GPDMA ((LPC_GPDMA_TypeDef *) LPC_GPDMA_BASE )
#define SCB_SHCSR_MEMFAULTACT_Msk (1ul << SCB_SHCSR_MEMFAULTACT_Pos)
#define SCB_ICSR_NMIPENDSET_Pos 31
#define LPC_UART3_BASE (LPC_APB1_BASE + 0x1C000)
#define ITM_TCR_TSPrescale_Msk (3ul << ITM_TCR_TSPrescale_Pos)
#define INT16_C(x) x
#define CoreDebug_DEMCR_MON_REQ_Pos 19
#define INT8_MAX 127
#define SCB_ICSR_ISRPENDING_Msk (1ul << SCB_ICSR_ISRPENDING_Pos)
#define UINT_LEAST64_MAX 18446744073709551615ULL
#define SCB_CFSR_USGFAULTSR_Msk (0xFFFFul << SCB_CFSR_USGFAULTSR_Pos)
#define SCB_SHCSR_USGFAULTACT_Pos 3
#define LPC_GPIO0_BASE (LPC_GPIO_BASE + 0x00000)
#define LPC_SC_BASE (LPC_APB1_BASE + 0x7C000)
#define SCB_DFSR_VCATCH_Msk (1ul << SCB_DFSR_VCATCH_Pos)
#define MPU_RASR_SRD_Pos 8
#define CoreDebug_DEMCR_MON_STEP_Msk (1ul << CoreDebug_DEMCR_MON_STEP_Pos)
#define CoreDebug_DEMCR_MON_EN_Msk (1ul << CoreDebug_DEMCR_MON_EN_Pos)
#define INT16_MAX 32767
#define CoreDebug_DEMCR_VC_BUSERR_Msk (1ul << CoreDebug_DEMCR_VC_BUSERR_Pos)
#define SCB_SHCSR_BUSFAULTPENDED_Pos 14
#define SCB_CCR_STKALIGN_Pos 9
#define MPU_RASR_C_Pos 17
#define LPC_GPDMACH0 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH0_BASE )
#define LPC_GPDMACH1 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH1_BASE )
#define LPC_GPDMACH2 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH2_BASE )
#define LPC_GPDMACH3 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH3_BASE )
#define LPC_GPDMACH4 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH4_BASE )
#define SCB_CPUID_PARTNO_Msk (0xFFFul << SCB_CPUID_PARTNO_Pos)
#define SysTick_CTRL_ENABLE_Pos 0
#define INT8_MIN -128
#define SCB_ICSR_PENDSTCLR_Pos 25
#define MPU_TYPE_DREGION_Pos 8
#define SCB_DFSR_BKPT_Msk (1ul << SCB_DFSR_BKPT_Pos)
#define MPU_RASR_S_Msk (1ul << MPU_RASR_S_Pos)
#define LPC_DAC ((LPC_DAC_TypeDef *) LPC_DAC_BASE )
#define SCB_CCR_DIV_0_TRP_Msk (1ul << SCB_CCR_DIV_0_TRP_Pos)
#define INT16_MIN -32768
#define SCB_ICSR_PENDSTSET_Pos 26
#define UINTMAX_C(x) x ##ULL
#define SCB_CCR_UNALIGN_TRP_Msk (1ul << SCB_CCR_UNALIGN_TRP_Pos)
#define LPC_GPDMACH7_BASE (LPC_AHB_BASE + 0x041E0)
#define SCB_SCR_SLEEPONEXIT_Pos 1
#define SCB_SHCSR_PENDSVACT_Pos 10
#define LPC_CANAF_RAM_BASE (LPC_APB0_BASE + 0x38000)
#define SysTick_CTRL_CLKSOURCE_Msk (1ul << SysTick_CTRL_CLKSOURCE_Pos)
#define InterruptType_ACTLR_DISDEFWBUF_Pos 1
#define ITM_TCR_TSENA_Msk (1ul << ITM_TCR_TSENA_Pos)
#define LPC_CAN1_BASE (LPC_APB0_BASE + 0x44000)
#define INT_FAST8_MAX __STDINT_EXP(INT_MAX)
#define LPC_MCPWM ((LPC_MCPWM_TypeDef *) LPC_MCPWM_BASE )
#define WCHAR_MAX __WCHAR_MAX__
#define CoreDebug_DHCSR_C_STEP_Pos 2
#define LPC_I2C2 ((LPC_I2C_TypeDef *) LPC_I2C2_BASE )
#define LPC_RAM_BASE (0x10000000UL)
#define SCB_HFSR_FORCED_Msk (1ul << SCB_HFSR_FORCED_Pos)
#define MPU_RBAR_ADDR_Msk (0x7FFFFFFul << MPU_RBAR_ADDR_Pos)
#define AUTOCONF_H 
#define SysTick_LOAD_RELOAD_Pos 0
#define MPU_RASR_B_Pos 16
#define INT_FAST8_MIN (-__STDINT_EXP(INT_MAX)-1)
#define ITM_TCR_SWOENA_Pos 4
#define WCHAR_MIN __WCHAR_MIN__
#define LPC_GPIO1_BASE (LPC_GPIO_BASE + 0x00020)
#define SysTick_CALIB_TENMS_Pos 0
#define CoreDebug_DHCSR_S_LOCKUP_Pos 19
#define SCB_SHCSR_MEMFAULTPENDED_Msk (1ul << SCB_SHCSR_MEMFAULTPENDED_Pos)
#define SCB_SHCSR_USGFAULTPENDED_Pos 12
#define ITM_TPR_PRIVMASK_Msk (0xFul << ITM_TPR_PRIVMASK_Pos)
#define SCB_VTOR_TBLOFF_Pos 7
#define UINT_FAST16_MAX (__STDINT_EXP(INT_MAX)*2U+1U)
#define CoreDebug_DHCSR_C_DEBUGEN_Msk (1ul << CoreDebug_DHCSR_C_DEBUGEN_Pos)
#define SysTick_CTRL_COUNTFLAG_Msk (1ul << SysTick_CTRL_COUNTFLAG_Pos)
#define UINT16_C(x) x
#define CoreDebug_DHCSR_S_RESET_ST_Pos 25
#define MPU_RASR_AP_Pos 24
#define InterruptType_ACTLR_DISFOLD_Msk (1ul << InterruptType_ACTLR_DISFOLD_Pos)
#define LPC_GPIOINT_BASE (LPC_APB0_BASE + 0x28080)
#define LPC_APB0_BASE (0x40000000UL)
#define MPU_TYPE_SEPARATE_Msk (1ul << MPU_TYPE_SEPARATE_Pos)
#define CoreDebug_DEMCR_VC_HARDERR_Msk (1ul << CoreDebug_DEMCR_VC_HARDERR_Pos)
#define SysTick_CALIB_NOREF_Msk (1ul << SysTick_CALIB_NOREF_Pos)
#define CoreDebug_DHCSR_S_HALT_Msk (1ul << CoreDebug_DHCSR_S_HALT_Pos)
#define ITM_IMCR_INTEGRATION_Msk (1ul << ITM_IMCR_INTEGRATION_Pos)
#define SCB_CCR_BFHFNMIGN_Pos 8
#define SCB_AIRCR_ENDIANESS_Msk (1ul << SCB_AIRCR_ENDIANESS_Pos)
#define LPC_CAN2_BASE (LPC_APB0_BASE + 0x48000)
#define SCB_HFSR_VECTTBL_Msk (1ul << SCB_HFSR_VECTTBL_Pos)
#define UINT8_MAX 255
#define CoreDebug_DHCSR_C_MASKINTS_Pos 3
#define CoreDebug_DEMCR_VC_NOCPERR_Msk (1ul << CoreDebug_DEMCR_VC_NOCPERR_Pos)
#define MPU_RASR_ENA_Msk (0x1Ful << MPU_RASR_ENA_Pos)
#define LPC_CM3_BASE (0xE0000000UL)
#define LPC_GPDMACH5 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH5_BASE )
#define CoreDebug_DEMCR_VC_CORERESET_Msk (1ul << CoreDebug_DEMCR_VC_CORERESET_Pos)
#define LPC_GPDMACH6 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH6_BASE )
#define MPU_RBAR_REGION_Pos 0
#define CoreDebug_DEMCR_TRCENA_Pos 24
#define SCB_AIRCR_PRIGROUP_Pos 8
#define SCB_ICSR_VECTACTIVE_Msk (0x1FFul << SCB_ICSR_VECTACTIVE_Pos)
#define SCB_CFSR_BUSFAULTSR_Pos 8
#define CoreDebug_DEMCR_VC_MMERR_Pos 4
#define SCB_ICSR_NMIPENDSET_Msk (1ul << SCB_ICSR_NMIPENDSET_Pos)
#define CoreDebug_DEMCR_MON_REQ_Msk (1ul << CoreDebug_DEMCR_MON_REQ_Pos)
#define InterruptType_ICTR_INTLINESNUM_Pos 0
#define SCB_SHCSR_USGFAULTACT_Msk (1ul << SCB_SHCSR_USGFAULTACT_Pos)
#define LPC_GPIO2_BASE (LPC_GPIO_BASE + 0x00040)
#define ITM_IWR_ATVALIDM_Pos 0
#define MPU_RASR_SRD_Msk (0xFFul << MPU_RASR_SRD_Pos)
#define SCB_SHCSR_MEMFAULTENA_Pos 16
#define SCB_SHCSR_BUSFAULTPENDED_Msk (1ul << SCB_SHCSR_BUSFAULTPENDED_Pos)
#define SCB_CCR_STKALIGN_Msk (1ul << SCB_CCR_STKALIGN_Pos)
#define MPU_RASR_C_Msk (1ul << MPU_RASR_C_Pos)
#define LPC_SPI ((LPC_SPI_TypeDef *) LPC_SPI_BASE )
#define CoreDebug_DHCSR_S_REGRDY_Pos 16
#define INT_FAST16_MAX __STDINT_EXP(INT_MAX)
#define SysTick_CTRL_ENABLE_Msk (1ul << SysTick_CTRL_ENABLE_Pos)
#define SCB_ICSR_PENDSTCLR_Msk (1ul << SCB_ICSR_PENDSTCLR_Pos)
#define SCB_CPUID_VARIANT_Pos 20
#define PTRDIFF_MAX __PTRDIFF_MAX__
#define SysTick_VAL_CURRENT_Pos 0
#define MPU_TYPE_DREGION_Msk (0xFFul << MPU_TYPE_DREGION_Pos)
#define ITM_IRR_ATREADYM_Pos 0
#define INT64_C(x) x ##LL
#define LPC_ADC ((LPC_ADC_TypeDef *) LPC_ADC_BASE )
#define SCB_ICSR_PENDSTSET_Msk (1ul << SCB_ICSR_PENDSTSET_Pos)
#define SCB_SCR_SLEEPONEXIT_Msk (1ul << SCB_SCR_SLEEPONEXIT_Pos)
#define SCB_SHCSR_PENDSVACT_Msk (1ul << SCB_SHCSR_PENDSVACT_Pos)
#define InterruptType_ACTLR_DISDEFWBUF_Msk (1ul << InterruptType_ACTLR_DISDEFWBUF_Pos)
#define INT_FAST16_MIN (-__STDINT_EXP(INT_MAX)-1)
#define SCS_BASE (0xE000E000)
#define ITM_TCR_DWTENA_Pos 3
#define PTRDIFF_MIN (-PTRDIFF_MAX - 1)
#define CoreDebug_DHCSR_C_STEP_Msk (1ul << CoreDebug_DHCSR_C_STEP_Pos)
#define SCB_DFSR_DWTTRAP_Pos 2
#define CoreDebug_DCRSR_REGSEL_Pos 0
#define LPC_PWM1_BASE (LPC_APB0_BASE + 0x18000)
#define CoreDebug_DHCSR_C_MASKINTS_Msk (1ul << CoreDebug_DHCSR_C_MASKINTS_Pos)
#define SCB_CPUID_REVISION_Pos 0
#define LPC_USB_BASE (LPC_AHB_BASE + 0x0C000)
#define PLL_PREDIV 2
#define SysTick ((SysTick_Type *) SysTick_BASE)
#define SysTick_LOAD_RELOAD_Msk (0xFFFFFFul << SysTick_LOAD_RELOAD_Pos)
#define MPU_RASR_B_Msk (1ul << MPU_RASR_B_Pos)
#define ITM_TCR_SWOENA_Msk (1ul << ITM_TCR_SWOENA_Pos)
#define LPC_GPIO3_BASE (LPC_GPIO_BASE + 0x00060)
#define SysTick_CALIB_TENMS_Msk (0xFFFFFFul << SysTick_VAL_CURRENT_Pos)
#define SCB_CCR_USERSETMPEND_Pos 1
#define MPU_CTRL_ENABLE_Pos 0
#define CoreDebug_DHCSR_S_LOCKUP_Msk (1ul << CoreDebug_DHCSR_S_LOCKUP_Pos)
#define LPC_SC ((LPC_SC_TypeDef *) LPC_SC_BASE )
#define CoreDebug_BASE (0xE000EDF0)
#define SCB_SHCSR_USGFAULTPENDED_Msk (1ul << SCB_SHCSR_USGFAULTPENDED_Pos)
#define LPC_WDT_BASE (LPC_APB0_BASE + 0x00000)
#define UINT_LEAST8_MAX 255
#define SCB_VTOR_TBLOFF_Msk (0x3FFFFFul << SCB_VTOR_TBLOFF_Pos)
#define ITM_TCR_SYNCENA_Pos 2
#define _GCC_WRAP_STDINT_H 
#define MPU_RASR_AP_Msk (7ul << MPU_RASR_AP_Pos)
#define PLL_MULTIPLIER 25
#define SCB_ICSR_VECTPENDING_Pos 12
#define SCB_ICSR_ISRPREEMPT_Pos 23
#define CoreDebug ((CoreDebug_Type *) CoreDebug_BASE)
#define SCB_SCR_SEVONPEND_Pos 4
#define SSP_CLK_DIVISOR 6
#define LPC_GPDMACH7 ((LPC_GPDMACH_TypeDef *) LPC_GPDMACH7_BASE )
#define SCB_SHCSR_SYSTICKACT_Pos 11
#define SCB_CCR_BFHFNMIGN_Msk (1ul << SCB_CCR_BFHFNMIGN_Pos)
#define LPC_SSP0 ((LPC_SSP_TypeDef *) LPC_SSP0_BASE )
#define LPC_SSP1 ((LPC_SSP_TypeDef *) LPC_SSP1_BASE )
#define CoreDebug_DHCSR_C_DEBUGEN_Pos 0
#define InterruptType_ACTLR_DISMCYCINT_Pos 0
#define SCB_HFSR_DEBUGEVT_Pos 31
#define SIZE_MAX __SIZE_MAX__
#define LPC_I2S ((LPC_I2S_TypeDef *) LPC_I2S_BASE )
#define CoreDebug_DHCSR_C_HALT_Msk (1ul << CoreDebug_DHCSR_C_HALT_Pos)
#define UINT64_C(x) x ##ULL
#define INT32_MIN (-2147483647L-1)
#define CONFIG_UART_DEBUG 
#define WINT_MAX __WINT_MAX__
#define LPC_PWM1 ((LPC_PWM_TypeDef *) LPC_PWM1_BASE )
#define UINTPTR_MAX __UINTPTR_MAX__
#define LPC_GPIO0 ((LPC_GPIO_TypeDef *) LPC_GPIO0_BASE )
#define LPC_GPIO1 ((LPC_GPIO_TypeDef *) LPC_GPIO1_BASE )
#define LPC_GPIO3 ((LPC_GPIO_TypeDef *) LPC_GPIO3_BASE )
#define LPC_GPIO4 ((LPC_GPIO_TypeDef *) LPC_GPIO4_BASE )
#define ITM_TCR_ATBID_Pos 16
#define UINT_LEAST16_MAX 65535
#define LPC_GPDMACH0_BASE (LPC_AHB_BASE + 0x04100)
#define MPU_RBAR_REGION_Msk (0xFul << MPU_RBAR_REGION_Pos)
#define CoreDebug_DEMCR_TRCENA_Msk (1ul << CoreDebug_DEMCR_TRCENA_Pos)
#define SCB_AIRCR_PRIGROUP_Msk (7ul << SCB_AIRCR_PRIGROUP_Pos)
#define SCB_SHCSR_BUSFAULTACT_Pos 1
#define UINT32_MAX 4294967295UL
#define LPC_CANAF_RAM ((LPC_CANAF_RAM_TypeDef *) LPC_CANAF_RAM_BASE)
#define SCB_CFSR_BUSFAULTSR_Msk (0xFFul << SCB_CFSR_BUSFAULTSR_Pos)
#define CoreDebug_DEMCR_VC_MMERR_Msk (1ul << CoreDebug_DEMCR_VC_MMERR_Pos)
#define InterruptType_ICTR_INTLINESNUM_Msk (0x1Ful << InterruptType_ICTR_INTLINESNUM_Pos)
#define LPC_GPIO4_BASE (LPC_GPIO_BASE + 0x00080)
#define ITM_IWR_ATVALIDM_Msk (1ul << ITM_IWR_ATVALIDM_Pos)
#define SCB_AIRCR_VECTKEYSTAT_Pos 16
#define LPC_GPIO2 ((LPC_GPIO_TypeDef *) LPC_GPIO2_BASE )
#define WINT_MIN __WINT_MIN__
#define MPU_CTRL_HFNMIENA_Pos 1
#define SCB_SHCSR_MEMFAULTENA_Msk (1ul << SCB_SHCSR_MEMFAULTENA_Pos)
#define LPC_RTC_BASE (LPC_APB0_BASE + 0x24000)
#define CoreDebug_DHCSR_S_RESET_ST_Msk (1ul << CoreDebug_DHCSR_S_RESET_ST_Pos)
#define CoreDebug_DHCSR_S_REGRDY_Msk (1ul << CoreDebug_DHCSR_S_REGRDY_Pos)
#define SCB_SHCSR_USGFAULTENA_Pos 18
#define INT_LEAST8_MAX 127
#define ITM_LSR_Access_Pos 1
#define CoreDebug_DHCSR_C_SNAPSTALL_Pos 5
#define SCB_CPUID_VARIANT_Msk (0xFul << SCB_CPUID_VARIANT_Pos)
#define CONFIG_UART_TX_BUF_SHIFT 14
#define SysTick_VAL_CURRENT_Msk (0xFFFFFFul << SysTick_VAL_CURRENT_Pos)
#define ITM_IRR_ATREADYM_Msk (1ul << ITM_IRR_ATREADYM_Pos)
#define INT_LEAST32_MAX 2147483647L
#define SCB_VTOR_TBLBASE_Pos 29
#define PLL_DIVISOR 3
#define INT_LEAST8_MIN -128
#define SCB_CPUID_IMPLEMENTER_Pos 24
#define ITM_TCR_DWTENA_Msk (1ul << ITM_TCR_DWTENA_Pos)
#define SCB_DFSR_DWTTRAP_Msk (1ul << SCB_DFSR_DWTTRAP_Pos)
#define CoreDebug_DEMCR_VC_INTERR_Pos 9
#define SCB_AIRCR_VECTRESET_Pos 0
#define INT_LEAST32_MIN (-2147483647L-1)
#define CoreDebug_DCRSR_REGSEL_Msk (0x1Ful << CoreDebug_DCRSR_REGSEL_Pos)
#define SCB_CPUID_REVISION_Msk (0xFul << SCB_CPUID_REVISION_Pos)
#define LPC_GPDMACH1_BASE (LPC_AHB_BASE + 0x04120)
#define CoreDebug_DEMCR_VC_CHKERR_Pos 6
#define LPC_UART0 ((LPC_UART0_TypeDef *) LPC_UART0_BASE )
#define LPC_UART1 ((LPC_UART1_TypeDef *) LPC_UART1_BASE )
#define LPC_UART2 ((LPC_UART_TypeDef *) LPC_UART2_BASE )
#define LPC_UART3 ((LPC_UART_TypeDef *) LPC_UART3_BASE )
#define CoreDebug_DHCSR_DBGKEY_Pos 16
#define LPC_PINCON_BASE (LPC_APB0_BASE + 0x2C000)
#define MPU_RNR_REGION_Pos 0
#define CoreDebug_DHCSR_S_SLEEP_Pos 18
#define JTAG_DELAY() asm volatile("nop\nnop\nnop\nnop\nnop\n")
#define SCB_CCR_USERSETMPEND_Msk (1ul << SCB_CCR_USERSETMPEND_Pos)
#define MPU_CTRL_ENABLE_Msk (1ul << MPU_CTRL_ENABLE_Pos)
#define SIG_ATOMIC_MAX __STDINT_EXP(INT_MAX)
#define MPU_RASR_XN_Pos 28
#define INT32_MAX 2147483647L
#define ITM_LSR_Access_Msk (1ul << ITM_LSR_Access_Pos)
#define SysTick_BASE (SCS_BASE + 0x0010)
#define _ARM_BITS_H 
#define ITM_RXBUFFER_EMPTY 0x5AA55AA5
#define SCB_ICSR_RETTOBASE_Pos 11
#define SCB_ICSR_VECTPENDING_Msk (0x1FFul << SCB_ICSR_VECTPENDING_Pos)
#define SCB_AIRCR_VECTCLRACTIVE_Pos 1
#define SCB_ICSR_ISRPREEMPT_Msk (1ul << SCB_ICSR_ISRPREEMPT_Pos)
#define UINT64_MAX 18446744073709551615ULL
#define SIG_ATOMIC_MIN (-__STDINT_EXP(INT_MAX) - 1)
#define SCB_SCR_SEVONPEND_Msk (1ul << SCB_SCR_SEVONPEND_Pos)
#define SCB_SHCSR_SYSTICKACT_Msk (1ul << SCB_SHCSR_SYSTICKACT_Pos)
#define SCB_CFSR_MEMFAULTSR_Pos 0
#define InterruptType_ACTLR_DISMCYCINT_Msk (1ul << InterruptType_ACTLR_DISMCYCINT_Pos)
#define SCB ((SCB_Type *) SCB_BASE)
#define SCB_HFSR_DEBUGEVT_Msk (1ul << SCB_HFSR_DEBUGEVT_Pos)
#define LPC_AHB_BASE (0x50000000UL)
#define SPI_ON_SSP 1
#define LPC_SSP1_BASE (LPC_APB0_BASE + 0x30000)
#define SCB_AIRCR_VECTKEY_Pos 16
#define SysTick_CTRL_TICKINT_Pos 1
#define LPC_SSP0_BASE (LPC_APB1_BASE + 0x08000)
#define INTPTR_MAX PTRDIFF_MAX
#define ITM_TCR_ATBID_Msk (0x7Ful << ITM_TCR_ATBID_Pos)
#define LPC_GPDMACH2_BASE (LPC_AHB_BASE + 0x04140)
#define UART_NUMBER 0
#define SCB_SHCSR_BUSFAULTACT_Msk (1ul << SCB_SHCSR_BUSFAULTACT_Pos)
#define BITBAND(addr,bit) (*((volatile unsigned long *)( ((unsigned long)&(addr) & 0x01ffffff)*32 + (bit)*4 + 0x02000000 + ((unsigned long)&(addr) & 0xfe000000) )))
#define INT_LEAST64_MAX 9223372036854775807LL
#define SCB_AIRCR_SYSRESETREQ_Pos 2
#define LONGVERSION "-"
#define ITM_LSR_Present_Pos 0
#define LPC_GPDMA_BASE (LPC_AHB_BASE + 0x04000)
#define SCB_AIRCR_VECTKEYSTAT_Msk (0xFFFFul << SCB_AIRCR_VECTKEYSTAT_Pos)
#define MPU_CTRL_HFNMIENA_Msk (1ul << MPU_CTRL_HFNMIENA_Pos)
#define INTPTR_MIN PTRDIFF_MIN
#define INT8_C(x) x
#define SCB_DFSR_BKPT_Pos 1
#define UINT_FAST32_MAX (__STDINT_EXP(INT_MAX)*2U+1U)
#define CONFIG_H 
#define SCB_SHCSR_MONITORACT_Pos 8
#define LPC_PINCON ((LPC_PINCON_TypeDef *) LPC_PINCON_BASE )
#define INT_LEAST64_MIN (-9223372036854775807LL-1LL)
#define SCB_SHCSR_USGFAULTENA_Msk (1ul << SCB_SHCSR_USGFAULTENA_Pos)
#define UINTMAX_MAX __UINTMAX_MAX__
#define SCB_BASE (SCS_BASE + 0x0D00)
#define INT32_C(x) x ##L
#define ITM_TCR_ITMENA_Pos 0
#define CoreDebug_DHCSR_C_SNAPSTALL_Msk (1ul << CoreDebug_DHCSR_C_SNAPSTALL_Pos)
#define LPC_CANAF ((LPC_CANAF_TypeDef *) LPC_CANAF_BASE )
#define LPC_QEI ((LPC_QEI_TypeDef *) LPC_QEI_BASE )
#define LPC_CANCR ((LPC_CANCR_TypeDef *) LPC_CANCR_BASE )
#define SCB_VTOR_TBLBASE_Msk (0x1FFul << SCB_VTOR_TBLBASE_Pos)
#define SCB_SHCSR_SVCALLPENDED_Pos 15
#define INT64_MAX 9223372036854775807LL
#define LPC_EMAC ((LPC_EMAC_TypeDef *) LPC_EMAC_BASE )
#define SCB_CPUID_IMPLEMENTER_Msk (0xFFul << SCB_CPUID_IMPLEMENTER_Pos)
#define MPU_TYPE_IREGION_Pos 16
#define CoreDebug_DEMCR_VC_INTERR_Msk (1ul << CoreDebug_DEMCR_VC_INTERR_Pos)
#define SCB_AIRCR_VECTRESET_Msk (1ul << SCB_AIRCR_VECTRESET_Pos)
#define SCB_SCR_SLEEPDEEP_Pos 2
#define LPC_TIM0_BASE (LPC_APB0_BASE + 0x04000)
#define LPC_GPDMACH3_BASE (LPC_AHB_BASE + 0x04160)
#define LPC_DAC_BASE (LPC_APB1_BASE + 0x0C000)
#define CoreDebug_DEMCR_VC_CHKERR_Msk (1ul << CoreDebug_DEMCR_VC_CHKERR_Pos)
#define CoreDebug_DEMCR_VC_STATERR_Pos 7
#define LPC_RIT_BASE (LPC_APB1_BASE + 0x30000)
#define SCB_ICSR_PENDSVCLR_Pos 27
#define CoreDebug_DHCSR_DBGKEY_Msk (0xFFFFul << CoreDebug_DHCSR_DBGKEY_Pos)
#define SysTick_CALIB_SKEW_Pos 30
#define MPU_RNR_REGION_Msk (0xFFul << MPU_RNR_REGION_Pos)
#define CoreDebug_DHCSR_S_SLEEP_Msk (1ul << CoreDebug_DHCSR_S_SLEEP_Pos)
#define INT64_MIN (-9223372036854775807LL-1LL)
#define CoreDebug_DHCSR_C_HALT_Pos 1
#define SCB_ICSR_PENDSVSET_Pos 28
#define LPC_I2C0 ((LPC_I2C_TypeDef *) LPC_I2C0_BASE )
#define LPC_I2C1 ((LPC_I2C_TypeDef *) LPC_I2C1_BASE )
#define LPC_ADC_BASE (LPC_APB0_BASE + 0x34000)
#define CONFIG_UART_PCLKDIV 1
#define SCB_CCR_NONBASETHRDENA_Pos 0
#define MPU_RASR_XN_Msk (1ul << MPU_RASR_XN_Pos)
#define LPC_CAN1 ((LPC_CAN_TypeDef *) LPC_CAN1_BASE )
#define LPC_CAN2 ((LPC_CAN_TypeDef *) LPC_CAN2_BASE )
#define LPC_UART0_BASE (LPC_APB0_BASE + 0x0C000)
#define SCB_ICSR_RETTOBASE_Msk (1ul << SCB_ICSR_RETTOBASE_Pos)
#define SCB_AIRCR_VECTCLRACTIVE_Msk (1ul << SCB_AIRCR_VECTCLRACTIVE_Pos)
#define INT_FAST32_MAX __STDINT_EXP(INT_MAX)
#define CONFIG_UART_DEADLOCKABLE 
#define UINT_FAST8_MAX (__STDINT_EXP(INT_MAX)*2U+1U)
#define SCB_DFSR_EXTERNAL_Pos 4
#define LPC_EMAC_BASE (LPC_AHB_BASE + 0x00000)
#define SCB_CFSR_MEMFAULTSR_Msk (0xFFul << SCB_CFSR_MEMFAULTSR_Pos)
#define ITM_TCR_BUSY_Pos 23
#define SCB_DFSR_HALTED_Pos 0
#define UINT32_C(x) x ##UL
#define MPU_RBAR_VALID_Pos 4
#define UINT_FAST64_MAX UINT_LEAST64_MAX
#define INT_FAST32_MIN (-__STDINT_EXP(INT_MAX)-1)
#define MPU_CTRL_PRIVDEFENA_Pos 2
#define SCB_AIRCR_VECTKEY_Msk (0xFFFFul << SCB_AIRCR_VECTKEY_Pos)
#define LPC_GPIO_BASE (0x2009C000UL)
#define SysTick_CTRL_TICKINT_Msk (1ul << SysTick_CTRL_TICKINT_Pos)
#define LPC_CANAF_BASE (LPC_APB0_BASE + 0x3C000)
#define InterruptType ((InterruptType_Type *) SCS_BASE)
#define LPC_TIM1_BASE (LPC_APB0_BASE + 0x08000)
#define CoreDebug_DHCSR_S_RETIRE_ST_Pos 24
#define LPC_GPDMACH4_BASE (LPC_AHB_BASE + 0x04180)
#define BV(x) (1<<(x))
#define CoreDebug_DCRSR_REGWnR_Pos 16
#define NVIC_BASE (SCS_BASE + 0x0100)
#define CoreDebug_DEMCR_MON_PEND_Pos 17
#define SCB_SHCSR_SVCALLACT_Pos 7
#define MPU_RASR_TEX_Pos 19
#define SCB_AIRCR_SYSRESETREQ_Msk (1ul << SCB_AIRCR_SYSRESETREQ_Pos)
#define ITM_LSR_Present_Msk (1ul << ITM_LSR_Present_Pos)
#define LPC_USB ((LPC_USB_TypeDef *) LPC_USB_BASE )
#define ITM_LSR_ByteAcc_Pos 2
#define LPC_I2C0_BASE (LPC_APB0_BASE + 0x1C000)
#define MPU_RASR_SIZE_Pos 1
#define SCB_SHCSR_BUSFAULTENA_Pos 17
#define SCB_SHCSR_MEMFAULTACT_Pos 0
#define SCB_SHCSR_MONITORACT_Msk (1ul << SCB_SHCSR_MONITORACT_Pos)
#define LPC_WDT ((LPC_WDT_TypeDef *) LPC_WDT_BASE )
#define LPC_UART1_BASE (LPC_APB0_BASE + 0x10000)
#define ITM_TCR_TSPrescale_Pos 8
#define ITM_TCR_SYNCENA_Msk (1ul << ITM_TCR_SYNCENA_Pos)
#define SCB_ICSR_ISRPENDING_Pos 22
#define SCB_CFSR_USGFAULTSR_Pos 16
#define INTMAX_MAX __INTMAX_MAX__
#define LPC_GPIOINT ((LPC_GPIOINT_TypeDef *) LPC_GPIOINT_BASE )
#define SCB_DFSR_VCATCH_Pos 3
#define ITM_TCR_ITMENA_Msk (1ul << ITM_TCR_ITMENA_Pos)
#define CoreDebug_DEMCR_MON_STEP_Pos 18
#define CoreDebug_DEMCR_MON_EN_Pos 16
#define CoreDebug_DEMCR_VC_BUSERR_Pos 8
#define NVIC ((NVIC_Type *) NVIC_BASE)
#define LPC_QEI_BASE (LPC_APB1_BASE + 0x3C000)
#define SCB_SHCSR_SVCALLPENDED_Msk (1ul << SCB_SHCSR_SVCALLPENDED_Pos)
#define SCB_CPUID_PARTNO_Pos 4
#define ITM_BASE (0xE0000000)
#define MPU_TYPE_IREGION_Msk (0xFFul << MPU_TYPE_IREGION_Pos)
#define INTMAX_MIN (-INTMAX_MAX - 1)
#define LPC_SPI_BASE (LPC_APB0_BASE + 0x20000)
#define MPU_RASR_S_Pos 18
#define SCB_SCR_SLEEPDEEP_Msk (1ul << SCB_SCR_SLEEPDEEP_Pos)
#define SCB_CCR_DIV_0_TRP_Pos 4
#define LPC_TIM2_BASE (LPC_APB1_BASE + 0x10000)
#define SCB_CCR_UNALIGN_TRP_Pos 3
#define INT_FAST64_MAX INT_LEAST64_MAX
#define LPC_GPDMACH5_BASE (LPC_AHB_BASE + 0x041A0)
#define UINT_LEAST32_MAX 4294967295UL
#define SysTick_CTRL_CLKSOURCE_Pos 2
#define CoreDebug_DEMCR_VC_STATERR_Msk (1ul << CoreDebug_DEMCR_VC_STATERR_Pos)
#define SCB_ICSR_PENDSVCLR_Msk (1ul << SCB_ICSR_PENDSVCLR_Pos)
#define ITM_TCR_TSENA_Pos 1
#define SysTick_CALIB_SKEW_Msk (1ul << SysTick_CALIB_SKEW_Pos)
#define ITM ((ITM_Type *) ITM_BASE)
#define SCB_ICSR_PENDSVSET_Msk (1ul << SCB_ICSR_PENDSVSET_Pos)
#define UINT8_C(x) x
#define SCB_HFSR_FORCED_Pos 30
#define LPC_I2C1_BASE (LPC_APB0_BASE + 0x5C000)
#define SCB_CCR_NONBASETHRDENA_Msk (1ul << SCB_CCR_NONBASETHRDENA_Pos)
#define INTMAX_C(x) x ##LL
#define INT_FAST64_MIN INT_LEAST64_MIN
#define _STDINT_H 
#define UINT16_MAX 65535
#define MPU_RBAR_ADDR_Pos 5
#define LPC_CANCR_BASE (LPC_APB0_BASE + 0x40000)
#define LPC_UART2_BASE (LPC_APB1_BASE + 0x18000)
#define SCB_SHCSR_MEMFAULTPENDED_Pos 13
#define LPC_FLASH_BASE (0x00000000UL)
#define LPC_RIT ((LPC_RIT_TypeDef *) LPC_RIT_BASE )
#define ITM_TPR_PRIVMASK_Pos 0
#define SCB_DFSR_EXTERNAL_Msk (1ul << SCB_DFSR_EXTERNAL_Pos)
#define MPU_BASE (SCS_BASE + 0x0D90)
#define VERSION "0.0.0"
#define SysTick_CTRL_COUNTFLAG_Pos 16
#define CoreDebug_DHCSR_S_RETIRE_ST_Msk (1ul << CoreDebug_DHCSR_S_RETIRE_ST_Pos)
#define ITM_TCR_BUSY_Msk (1ul << ITM_TCR_BUSY_Pos)
#define CONFIG_UART_BAUDRATE 115200
#define SCB_DFSR_HALTED_Msk (1ul << SCB_DFSR_HALTED_Pos)
#define InterruptType_ACTLR_DISFOLD_Pos 2
#define F_CPU UL
#define MPU_RBAR_VALID_Msk (1ul << MPU_RBAR_VALID_Pos)
#define MPU_TYPE_SEPARATE_Pos 0
#define MPU_CTRL_PRIVDEFENA_Msk (1ul << MPU_CTRL_PRIVDEFENA_Pos)
#define CoreDebug_DEMCR_VC_HARDERR_Pos 10
#define SysTick_CALIB_NOREF_Pos 31
#define INT_LEAST16_MAX 32767
#define LPC_MCPWM_BASE (LPC_APB1_BASE + 0x38000)
#define CoreDebug_DHCSR_S_HALT_Pos 17
#define LPC_TIM0 ((LPC_TIM_TypeDef *) LPC_TIM0_BASE )
#define LPC_APB1_BASE (0x40080000UL)
#define ITM_IMCR_INTEGRATION_Pos 0
#define LPC_TIM3_BASE (LPC_APB1_BASE + 0x14000)
#define LPC_I2S_BASE (LPC_APB1_BASE + 0x28000)
#define LPC_TIM1 ((LPC_TIM_TypeDef *) LPC_TIM1_BASE )
#define LPC_TIM2 ((LPC_TIM_TypeDef *) LPC_TIM2_BASE )
#define LPC_TIM3 ((LPC_TIM_TypeDef *) LPC_TIM3_BASE )
#define LPC_GPDMACH6_BASE (LPC_AHB_BASE + 0x041C0)
