/*
 * ARM JTAG Fault Injector
 *
 * Author: Andreas Heinig <andreas.heinig@gmx.de>
 *
 * Copyright (C) 2011-2014 Department of Computer Science,
 * Design Automation of Embedded Systems Group,
 * Dortmund University of Technology, all rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   3. Neither the name of the copyright holder nor the names of its
 *      contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef PARAMETERS_H__INCLUDED__
#define PARAMETERS_H__INCLUDED__

#include "injtypes.h"
#define RAM32
#define RAM2

#define PARAM_TICK_INTERVAL		5	/* ms */
#if 0
#define DEFAULT_PARAM_INST_CHECK_RATE	6	/* ticks */
#define PARAM_MAIN_DELAY		4	/* ticks */
#define DEFAULT_PARAM_MEM_ERROR_RATE	50	/* ticks */
#define DEFAULT_PARAM_REG_ERROR_RATE	2000	/* ticks */
#else
#define DEFAULT_PARAM_INST_CHECK_RATE	10	/* ticks */
#define PARAM_MAIN_DELAY		4	/* ticks */
#define DEFAULT_PARAM_MEM_ERROR_RATE	100	/* ticks */
#define DEFAULT_PARAM_REG_ERROR_RATE	1000	/* ticks */
#endif

#define ERROR_DEV_VBASE		0xfff30000

#define RAM_INJ_VBASE		0x10000000
#define RAM_INJ_SIZE		((128 + 32) * 1024 * 1024)

#define INJECT_DEFAULT_FLAGS	(SINGLE_STEP_MODE | ENABLE_INJECT | INJECT_TO_MEM | ENABLE_FLIP)

#endif /* PARAMETERS_H__INCLUDED__ */
