/*
 * ARM JTAG Fault Injector
 *
 * Author: Andreas Heinig <andreas.heinig@gmx.de>
 *
 * Copyright (C) 2011-2014 Department of Computer Science,
 * Design Automation of Embedded Systems Group,
 * Dortmund University of Technology, all rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   3. Neither the name of the copyright holder nor the names of its
 *      contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "random.h"

#include <stdlib.h>

#define RAND_BUFFER_SIZE 16
int rand_buffer[RAND_BUFFER_SIZE];
unsigned int rand_buffer_rpos;
unsigned int rand_buffer_wpos;

void random_init(void)
{
	unsigned int i;
	for(i = 0; i < RAND_BUFFER_SIZE; i++)
		rand_buffer[i] = rand();
	rand_buffer_wpos = 0;
	rand_buffer_rpos = 0;
}

void random_fill(void)
{
        while(rand_buffer_wpos != rand_buffer_rpos)
        {
                rand_buffer[rand_buffer_wpos++] = rand();
                if(rand_buffer_wpos >= RAND_BUFFER_SIZE)
                        rand_buffer_wpos = 0;
        }
}

int random_get(void)
{
	int randval = rand_buffer[rand_buffer_rpos++];
	if(rand_buffer_rpos >= RAND_BUFFER_SIZE)
		rand_buffer_rpos = 0;
	return randval;
}
